
title_scrollcnt:  db    0
titlescrollptr:   dw    0

titlescroll.txt:
                  db    1
                  db    "WELCOME TO ",34,"BOOM BOT!",34,2,".",1
                  db    "  A CRAP GAME RELEASED TO CELEBRATE THE 25th ANNIVERSARY OF THE SINCLAIR ZX SPECTRUM"
                  db    "    "
                  db    255

InitTitles:       ld    hl,49152
                  ld    de,49153
                  ld    bc,16383
                  ld    (hl),l
                  ldir

                  xor   a
                  ld    (title_scrollcnt),a

                  ld    hl,titlescroll.txt
                  ld    (titlescrollptr),hl
                  ret

UpdateTitles:     call  ClearBackBuffer

                  call  Scroll_Title

                  ld    a,(title_scrollcnt)
                  inc   a
                  and   7
                  ld    (title_scrollcnt),a
                  call  z,Title_Char

                  ld    de,#cf13
                  call  DrawScreen

                  call  CopyBackBuffer
                  ret

Title_Char:       ld    hl,(titlescrollptr)
T_C_0:            ld    a,(hl)
                  inc   hl
                  cp    255
                  jr    nz,T_C_1

                  ld    hl,titlescroll.txt
                  jr    T_C_0

T_C_1:            cp    8
                  jr    nc,T_C_2

                  ld    (D_B_HeightVal+1),a
                  jr    T_C_0

T_C_2:            ld    (titlescrollptr),hl
                  ld    hl,#de07
                ; continue into 'Draw_Block_Char' to render this character

Draw_Block_Char:  ex    de,hl
                  ld    h,0
                  ld    l,a
                  add   hl,hl
                  add   hl,hl
                  add   hl,hl
                  ld    a,#3c       ; add 15360 to HL. base address of ROM chars - 256
                  add   a,h
                  ld    h,a
                  ex    de,hl

                  ld    b,8
D_B_C_1:          push  hl
                  ld    a,(de)
                  ld    c,8
D_B_C_2:          ld    (hl),0
                  rla
                  jr    nc,D_B_C_3
D_B_HeightVal:    ld    (hl),1

D_B_C_3:          inc   h
                  dec   c
                  jr    nz,D_B_C_2

                  pop   hl
                  dec   l
                  inc   de
                  djnz  D_B_C_1
                  ret

Scroll_Title:     ld    a,#c0
                  ld    b,#25
Scr_T1:           ld    d,a
                  ld    e,0
                  inc   a
                  ld    h,a
                  ld    l,e
                  ld    c,255
                  db    237,160,237,160,237,160,237,160,237,160,237,160,237,160,237,160   ; 8 x LDI
                  djnz  Scr_T1
                  ret





